# 🔥 pipenet-tools

Front end packaging tool for ZZHT

[![npm][npm]][npm-url]
[![node][node]][node-url]
[![tests][tests]][tests-url]
[![prs][prs]][prs-url]
[![code style: prettier](https://img.shields.io/badge/code_style-prettier-ff69b4.svg?style=flat-square)](https://github.com/prettier/prettier)

## Get Started

### Install

```shell script
npm i pipenet-tools --save-dev
```

### Configuration

`config/config.ts`

```ts

import { defineConfig } from 'pipenet-tools';

export default defineConfig({
  // entry file named `router.ts`， relative to ./src
  scan: ['router.ts'],
  port: 9000,
  eslint: true,
  log: false,
  typescript: true,
  docker: './docker',
});


```

### Add Scripts

在 package.json中添加script

```json
{
  "scripts": {
    "start": "pipenet-tools start",
    "build": "pipenet-tools build"
  }
}
```

## License

This source code is for internal communication only

[npm]: https://img.shields.io/static/v1?label=npm&message=2.12.0&color=blue

[npm-url]: https://www.npmjs.com/package/pipenet-tools

[node]: https://img.shields.io/static/v1?label=npm&message=>=12.22.0&color=blue

[node-url]: https://nodejs.org

[tests]: https://img.shields.io/travis/webpack/webpack/master.svg

[tests-url]: #

[prs]: https://img.shields.io/badge/PRs-welcome-brightgreen.svg

[prs-url]: #

