"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;
var _utils = require("../utils");
function _default(_api, opts) {
  const nodeEnv = opts.nodeEnv;
  delete opts['nodeEnv'];
  const nextOpts = (0, _utils.deepmerge)({
    typescript: true,
    env: {
      loose: false,
      useBuiltIns: 'entry',
      corejs: 3,
      modules: false,
      targets: {
        chrome: 49,
        firefox: 64,
        safari: 10,
        edge: 13,
        ios: 10,
        ie: 11
      }
    },
    react: {
      development: nodeEnv === 'development'
    },
    transformRuntime: {},
    reactRemovePropTypes: nodeEnv === 'production'
  }, opts);
  if (opts.env.targets) {
    nextOpts.env.targets = opts.env.targets;
  }
  return {
    presets: [[require.resolve('./src/typescript'), nextOpts]]
  };
}