"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;
function _path() {
  const data = require("path");
  _path = function _path() {
    return data;
  };
  return data;
}
var _utils = require("../../utils");
function toObject(obj) {
  return typeof obj === 'object' ? obj : {};
}
function _default(_context, opts = {}) {
  const defaultEnvConfig = {
    exclude: ['transform-typeof-symbol', 'transform-unicode-regex', 'transform-sticky-regex', 'transform-new-target', 'transform-modules-umd', 'transform-modules-systemjs', 'transform-modules-amd', 'transform-literals']
  };
  const plugins = [[require.resolve('@babel/plugin-transform-destructuring'), {
    loose: false
  }], require.resolve('@babel/plugin-syntax-dynamic-import'), require.resolve('@babel/plugin-proposal-optional-catch-binding'), [require.resolve('@babel/plugin-transform-typescript'), {
    allowDeclareFields: true
  }],
  // 下面两个的顺序的配置都不能动
  [require.resolve('@babel/plugin-proposal-decorators'), {
    legacy: true
  }], [require.resolve('@babel/plugin-proposal-class-properties'), {
    loose: true
  }], [require.resolve('@babel/plugin-proposal-private-methods'), {
    loose: true
  }], ['@babel/plugin-transform-private-property-in-object', {
    loose: true
  }], require.resolve('@babel/plugin-proposal-export-namespace-from'), require.resolve('@babel/plugin-proposal-export-default-from'), [require.resolve('@babel/plugin-proposal-nullish-coalescing-operator'), {
    loose: false
  }], [require.resolve('@babel/plugin-proposal-optional-chaining'), {
    loose: false
  }], [require.resolve('@babel/plugin-proposal-pipeline-operator'), {
    proposal: 'minimal'
  }], require.resolve('@babel/plugin-proposal-do-expressions'), require.resolve('@babel/plugin-proposal-function-bind'), require.resolve('@babel/plugin-proposal-logical-assignment-operators'), [require.resolve('@babel/plugin-transform-runtime'), {
    version: require('@babel/runtime/package.json').version,
    // https://babeljs.io/docs/en/babel-plugin-transform-runtime#absoluteruntime
    // lock the version of @babel/runtime
    // make sure we are using the correct version
    absoluteRuntime: (0, _path().dirname)(require.resolve('@babel/runtime/package.json')),
    // https://babeljs.io/docs/en/babel-plugin-transform-runtime#useesmodules
    useESModules: true
  }]];
  if (opts.reactRemovePropTypes) {
    plugins.push([require.resolve('babel-plugin-transform-react-remove-prop-types'), {
      removeImport: true
    }]);
  }
  if (opts.import) {
    opts.import.forEach(importOpts => {
      plugins.push([require.resolve('babel-plugin-import'), importOpts, importOpts.libraryName]);
    });
  }
  if (opts.lodash) {
    plugins.push([require.resolve('babel-plugin-lodash'), typeof opts.lodash === 'boolean' ? {} : opts.lodash]);
  }
  return {
    presets: [[require.resolve('@babel/preset-env'), (0, _utils.deepmerge)(defaultEnvConfig, toObject(opts.env))], require.resolve('@babel/preset-react'), [require.resolve('@babel/preset-typescript'), {
      // https://babeljs.io/docs/en/babel-plugin-transform-typescript#impartial-namespace-support
      allowNamespaces: true,
      allowDeclareFields: true
    }]],
    plugins
  };
}