"use strict";

function _yargs() {
  const data = _interopRequireDefault(require("yargs"));
  _yargs = function _yargs() {
    return data;
  };
  return data;
}
function _helpers() {
  const data = require("yargs/helpers");
  _helpers = function _helpers() {
    return data;
  };
  return data;
}
var _changeLog = _interopRequireDefault(require("./scripts/changeLog"));
var _utils = require("./utils");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); } /* eslint-disable  @typescript-eslint/no-require-imports*/
// eslint-disable-next-line @typescript-eslint/no-unused-expressions
(0, _yargs().default)((0, _helpers().hideBin)(process.argv)).scriptName('pipenet-tools').usage('pipenet-tools [command] <options>').config('config', 'a external config file').command('log [options]', 'to generate git commit log', ya => ya.option('owner', {
  describe: 'the owner section generated link',
  type: 'string'
}).option('commit', {
  describe: 'the commit section generated link',
  type: 'string'
}).option('host', {
  describe: 'the host section generated link',
  type: 'string'
}).option('verbose', {
  type: 'boolean',
  describe: 'Run with verbose logging',
  default: true
}), args => {
  (0, _changeLog.default)((0, _utils.filterEmptyKey)(_objectSpread({}, args), ['_', '$0']));
}).command('build', 'Compiles an app into an output directory with production mode. Must be executed from within a workspace directory.', ya => {
  ya.option('pack', {
    describe: 'build and then pack to a archiver file',
    type: 'boolean',
    default: false
  });
  ya.option('pack-only', {
    describe: 'pack to a archiver file only',
    type: 'boolean',
    default: false
  });
}, args => {
  const script = args._[0];
  if (args['pack']) {
    return require(`./scripts/pack`);
  }
  if (args['pack-only']) {
    return require(`./scripts/pack-only`);
  }
  return require(`./scripts/${script}`);
}).command('dev', 'Compiles an app into an output directory with development mode. Must be executed from within a workspace directory.', ya => ya.option('watch', {
  describe: 'watch mode',
  type: 'boolean',
  default: true
}), args => {
  const m = require(`./scripts/dev-watch`).default;
  return m({
    watch: args.watch && process.env.WATCH !== 'none',
    env: 'development'
  });
}).command('ans', 'analysis webpack bundle.', ya => ya.option('port', {
  describe: 'ans server port',
  type: 'number',
  default: 9078
}), args => {
  // const script = args._[0];
  const m = require(`./scripts/ans`);
  m(args.port);
}).command('git-tag', 'Adds a git tag to your project.', {}, args => {
  const script = args._[0];
  return require(`./scripts/${script}`);
}).command('test', 'Runs unit tests in a project', ya => ya.option('coverage', {
  describe: 'generate coverage report',
  type: 'boolean',
  default: false
}), args => {
  const script = args._[0];
  return require(`./scripts/${script}`);
}).command('start', 'Builds and serves your app, rebuilding on file changes.', {}, args => {
  const script = args._[0];
  return require(`./scripts/${script}`);
}).version(require('../package.json').version).demandCommand(1).strict().argv;