"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getBabelOpts = getBabelOpts;
exports.getBabelPresetOpts = getBabelPresetOpts;
exports.getTSBabelOpts = getTSBabelOpts;
function _fsExtra() {
  const data = require("fs-extra");
  _fsExtra = function _fsExtra() {
    return data;
  };
  return data;
}
function _path() {
  const data = require("path");
  _path = function _path() {
    return data;
  };
  return data;
}
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function getBasicBabelLoaderOpts({
  cwd
}) {
  const prefix = (0, _fsExtra().existsSync)((0, _path().join)(cwd, 'src')) ? 'src/' : '';
  return {
    // Tell babel to guess the type, instead assuming all files are modules
    // https://github.com/webpack/webpack/issues/4039#issuecomment-419284940
    sourceType: 'unambiguous',
    babelrc: false,
    cacheDirectory: process.env.CACHE !== 'none' // ? `${prefix}.ppt/.cache/babel-loader` : false,
  };
}

function getBabelPresetOpts(opts) {
  var _opts$lodashOptions;
  return {
    nodeEnv: opts.mode,
    env: {
      targets: opts.targets || {
        chrome: 49,
        firefox: 64,
        safari: 10,
        edge: 13,
        ios: 10,
        ie: 11
      }
    },
    import: opts.babelImport || [
    // { libraryName: 'antd', libraryDirectory: 'es', style: true },
    {
      libraryName: 'antd-mobile',
      libraryDirectory: 'es',
      style: true
    }, {
      libraryName: 'yd',
      libraryDirectory: 'es',
      style: true
    }, {
      libraryName: 'yd-form',
      libraryDirectory: 'es',
      style: true
    }, {
      libraryName: 'react-map-esri',
      libraryDirectory: 'es',
      style: true
    }],
    lodash: !opts.lodashOptions ? false : opts.lodashOptions === true ? {} : (opts === null || opts === void 0 ? void 0 : (_opts$lodashOptions = opts.lodashOptions) === null || _opts$lodashOptions === void 0 ? void 0 : _opts$lodashOptions.babel) || {}
  };
}
function getBabelOpts({
  cwd,
  presetOpts
}) {
  return _objectSpread(_objectSpread({}, getBasicBabelLoaderOpts({
    cwd
  })), {}, {
    presets: [[require.resolve('../babel-preset-ppt/app'), presetOpts]],
    plugins: []
  });
}
function getTSBabelOpts({
  cwd,
  presetOpts
}) {
  return _objectSpread(_objectSpread({}, getBasicBabelLoaderOpts({
    cwd
  })), {}, {
    presets: [[require.resolve('../babel-preset-ppt/app-typescript'), presetOpts]],
    plugins: []
  });
}