"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;
exports.getPreConfig = getPreConfig;
function _fs() {
  const data = require("fs");
  _fs = function _fs() {
    return data;
  };
  return data;
}
function _chalk() {
  const data = _interopRequireDefault(require("chalk"));
  _chalk = function _chalk() {
    return data;
  };
  return data;
}
function _path() {
  const data = _interopRequireDefault(require("path"));
  _path = function _path() {
    return data;
  };
  return data;
}
function _assert() {
  const data = _interopRequireDefault(require("assert"));
  _assert = function _assert() {
    return data;
  };
  return data;
}
var log = _interopRequireWildcard(require("../log"));
var _utils = require("../utils");
var _postcssConfig = _interopRequireDefault(require("./postcssConfig"));
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && Object.prototype.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
const CONFIG_FILES = ['config/config.ts', 'config/config.js'];
function getConfigFile(cwd) {
  const configFile = CONFIG_FILES.find(f => (0, _fs().existsSync)(_path().default.join(cwd, f)));
  return configFile ? (0, _utils.winPath)(configFile) : null;
}
/**
 * 添加后缀
 *
 * @param file
 * @param affix
 */
function addAffix(file, affix) {
  const ext = _path().default.extname(file);
  return file.replace(new RegExp(`${ext}$`), `.${affix}${ext}`);
}
function requireConfigs(configFiles) {
  // eslint-disable-next-line @typescript-eslint/no-require-imports
  return configFiles.map(f => (0, _utils.compatESModuleRequire)(require(f)));
}
function mergeConfig(...configs) {
  let ret = {};
  for (var _i = 0, _configs = configs; _i < _configs.length; _i++) {
    const config = _configs[_i];
    // TODO: 精细化处理，比如处理 dotted config key
    ret = (0, _utils.deepmerge)(ret, config, {
      arrayMerge: (_target, source) => source
    });
  }
  return ret;
}
function _default({
  cwd,
  env
}) {
  var _userConfig$devtool;
  // eslint-disable-next-line @typescript-eslint/no-require-imports
  const pkg = require(_path().default.resolve(cwd, 'package.json'));
  const isDev = env === 'development';
  const configFile = getConfigFile(cwd);
  let userConfig;
  let files = [];
  if (process.env.PPT_ENV) {
    const envConfigFile = addAffix(configFile, process.env.PPT_ENV);
    (0, _assert().default)((0, _fs().existsSync)(envConfigFile), _chalk().default.red(`get user config failed, ${envConfigFile} does not exist, but process.env.PPT_ENV is set to ${process.env.PPT_ENV}.`));
    files = [configFile, envConfigFile, isDev && addAffix(configFile, 'local')].filter(f => !!f).filter(f => (0, _fs().existsSync)(f)).map(f => _path().default.join(cwd, f));
    userConfig = mergeConfig(...requireConfigs(files));
  } else {
    (0, _assert().default)((0, _fs().existsSync)(configFile), _chalk().default.red(`${configFile} 配置文件不存在`));
    files = [configFile, addAffix(configFile, 'local')].filter(f => !!f).filter(f => (0, _fs().existsSync)(f)).map(f => _path().default.join(cwd, f));
    userConfig = mergeConfig(...requireConfigs(files));
    // 开发者模式下，以 dev 内容为主，不再推荐使用
    if (isDev && userConfig.dev) {
      userConfig = _objectSpread(_objectSpread({}, userConfig), userConfig.dev);
    }
    delete userConfig.dev;
  }
  log.setLogLevel(userConfig.log);
  log.log(files);
  log.log('当前 userConfig 配置信息：');
  log.log(userConfig);
  const base = userConfig.base || './src';
  const baseLess = userConfig.baseLess || './src';
  if (userConfig.useLess) {
    userConfig.log && _utils.printLog.warning(`当前模式下，无法使用 import { Button } from 'antd'; 这种方式进行组件引用`);
  }
  if (userConfig.hasOwnProperty('docker')) {
    userConfig.dist = _path().default.resolve(userConfig.docker, 'capsule');
  }
  const dist = (0, _utils.winPath)(userConfig.dist || '');
  (0, _assert().default)(dist !== '', _chalk().default.red('config.js 中的 dist 参数配置为空'));
  const distIsAbsolute = _path().default.isAbsolute(dist);
  if (!distIsAbsolute) {
    /**
     * 某些特殊场景，会出现神奇的 8206 8296
     * 相关 code 意义：https://www.runoob.com/charsets/ref-utf-punctuation.html
     */
    log.log(`当前的起始 char 码为: ` + dist.charCodeAt(0));
  }
  const absDir = distIsAbsolute ? _path().default.resolve(dist) : _path().default.resolve(cwd, dist);
  log.log('absDir: ' + absDir);
  // 判断是否需要开启 routerIndex 模式
  let routerIndex = false;
  if (Array.isArray(userConfig.scan) && userConfig.scan.length === 1 && /[\/-]?router(-\w+)?\.[tj]s$/.test(userConfig.scan[0])) {
    routerIndex = true;
  }
  return _objectSpread(_objectSpread({
    layout: false,
    scene: 'dev'
  }, userConfig), {}, {
    dynamicCssUrlOptions: _objectSpread({
      enabled: !!userConfig.dynamicPublicPath
    }, userConfig.dynamicCssUrlOptions),
    base,
    baseLess,
    routerIndex,
    absDir,
    projectName: pkg.name,
    cwd,
    reactRemovePropTypes: !isDev,
    mode: env,
    pkg,
    devtool: (_userConfig$devtool = userConfig.devtool) !== null && _userConfig$devtool !== void 0 ? _userConfig$devtool : 'source-map'
  });
}
function getPreConfig(userConfig) {
  const modifyVars = _objectSpread({}, userConfig.modifyLessVars);
  const modifyPrefixConfig = _objectSpread({}, userConfig.modifyPrefix);
  const prefixConfig = _objectSpread(_objectSpread({}, modifyPrefixConfig.prefix), userConfig.prefixConfig);
  let antPrefix = 'ant';
  if (modifyVars['@ant-prefix'] && !prefixConfig['ant-']) {
    prefixConfig['ant-'] = modifyVars['@ant-prefix'] + '-';
    antPrefix = modifyVars['@ant-prefix'];
  }
  const useRem = userConfig.useRem,
    remConfig = userConfig.remConfig,
    autoPrefixerOptions = userConfig.autoPrefixerOptions,
    less2CssVarConfig = userConfig.less2CssVarConfig,
    dynamicPublicPath = userConfig.dynamicPublicPath,
    dynamicCssUrlOptions = userConfig.dynamicCssUrlOptions;
  const postcssOptions = (0, _postcssConfig.default)({
    autoPrefixerOptions,
    remEnable: useRem,
    remConfig,
    prefixConfig: _objectSpread(_objectSpread({}, modifyPrefixConfig), {}, {
      enabled: Object.keys(prefixConfig).length > 0,
      prefix: prefixConfig
    }),
    less2CssVarConfig: _objectSpread({
      enabled: false
    }, less2CssVarConfig),
    dynamicCssUrlConfig: _objectSpread({
      enabled: dynamicPublicPath === true
    }, dynamicCssUrlOptions)
  });
  return {
    antPrefix,
    postcssConfig: postcssOptions,
    modifyVars
  };
}