"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
function _postcss() {
  const data = _interopRequireDefault(require("postcss"));
  _postcss = function _postcss() {
    return data;
  };
  return data;
}
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
const pluginName = 'postcss-less2var';
const plugin = options => {
  if (!options) {
    throw new Error(`[${pluginName}]: you must provide options to use this plugin`);
  }
  const excludes = options.excludes;
  const includes = options.includes;
  const ignore = (options.ignore || []).map(v => typeof v === 'function' ? v : (_, value) => v.test(value));
  const test = options.test;
  const replaceVar = prevValue => {
    const reg = /(?<=\s*|^)@([\w-]+)(?<=\s*\b|$)/;
    if (!reg.test(prevValue)) {
      return prevValue;
    }
    const regC = /^~['"]@|^shade\(/;
    if (regC.test(prevValue)) {
      return prevValue;
    }
    const regE = /@([\w-]+)\b(?=\s*[\-+*/]\s*(@|\d))/;
    const reg3 = /^(?<=\s*)-@([\w-]+)(?<=\s*)/g;
    const reg2 = /(?<=\s*)@([\w-]+)(?<=\s*)/g;
    /**
     * @type {RegExpExecArray|null}
     */
    let tmp;
    let rs = prevValue;
    while ((tmp = reg2.exec(prevValue)) !== null) {
      const _tmp = tmp,
        _tmp2 = _slicedToArray(_tmp, 2),
        lessVarName = _tmp2[0],
        varName = _tmp2[1];
      rs = rs.replace(lessVarName, `var(--lt-${varName}) `);
    }
    if (reg3.test(prevValue)) {
      return `calc(-1 * ${rs.substring(1)})`;
    }
    if (regE.test(prevValue)) {
      return `calc(${rs})`;
    }
    return rs;
  };
  const isMatch = file => {
    if (!file) {
      return false;
    }
    const normalFilePath = file.replace(/\\/g, '/');
    if (test) {
      return test(normalFilePath);
    }
    if (!excludes && !includes) {
      return true;
    }
    if (excludes && includes) {
      return excludes.every(v => !v.test(normalFilePath)) && includes.some(v => v.test(normalFilePath));
    }
    if (excludes) {
      return excludes.every(v => !v.test(normalFilePath));
    }
    return includes.some(v => v.test(normalFilePath));
  };
  /**
   * @type {Object.<string,string>}
   */
  let appends = {};
  return {
    postcssPlugin: pluginName,
    Once(root) {
      const file = root.source.input.file;
      if (!isMatch(file)) {
        return;
      }
      root.walk(node => {
        if (node.type === 'atrule') {
          const rule = node;
          if (!rule.nodes && rule.value && /\s*:\s*/.test(node.raws.afterName)) {
            let value = replaceVar(rule.value);
            if (/^\s*ey/.test(value)) {
              console.log(node.name, value);
              return;
            }
            if (value === '0px') {
              value = '0';
            }
            appends[node.name] = value;
          }
        } else if (node.type === 'decl') {
          const decl = node;
          const prevValue = decl.value;
          const prop = decl.prop;
          const reg = /(?<=\s*|^)@([\w-]+)(?<=\s*\b|$)/;
          if (reg.test(prevValue)) {
            if (ignore.some(v => v(prop, prevValue))) {
              return;
            }
            decl.value = replaceVar(prevValue);
          }
        }
      });
    },
    OnceExit(root) {
      const entries = Object.entries(appends);
      const globalMenuEntries = [];
      const privateMenuEntries = [];
      entries.forEach(([name, value]) => {
        if (/-prefix$/.test(name)) {
          return;
        }
        const entries = /^v-(sub|menu)/.test(name) ? privateMenuEntries : globalMenuEntries;
        entries.push(_postcss().default.decl({
          prop: '--lt-' + name,
          value
        }));
      });
      const rule = _postcss().default.rule({
        selector: '[hope-layout-theme]',
        nodes: globalMenuEntries
      });
      const menuRule = _postcss().default.rule({
        selectors: ['[hope-layout-theme] > body'],
        nodes: privateMenuEntries
      });
      root.insertBefore(root.first, menuRule);
      root.insertBefore(root.first, rule);
      appends = {};
    }
  };
};
plugin.postcss = true;
var _default = exports.default = plugin;