"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
function _path() {
  const data = _interopRequireDefault(require("path"));
  _path = function _path() {
    return data;
  };
  return data;
}
var _cssVar = _interopRequireWildcard(require("./cssVar"));
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && Object.prototype.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }
function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }
const URL_PATTERNS = [/(url\(\s*['"]?)([^"')]+)(["']?\s*\))/g, /(AlphaImageLoader\(\s*src=['"]?)([^"')]+)(["'])/g];
const getPattern = decl => URL_PATTERNS.find(pattern => pattern.test(decl.value));
const getVarByPath = url => {
  return '--' + url.split(/[\/.]/).filter(Boolean).join('-');
};
const declProcessor = /*#__PURE__*/function () {
  var _ref = _asyncToGenerator(function* (_from, _to, _options, _result, decl) {
    const pattern = getPattern(decl);
    if (!pattern) {
      return false;
    }
    const roots = {};
    let flag = false;
    decl.value = decl.value.replace(pattern, (input, _pre, url, _suf) => {
      const trimUrl = url.trim();
      if (trimUrl.indexOf('/') !== 0) {
        return input;
      }
      flag = true;
      const key = trimUrl;
      if (!roots[key]) {
        roots[key] = getVarByPath(trimUrl);
      }
      return `var(${roots[key]})`;
    });
    return flag ? roots : false;
  });
  return function declProcessor(_x, _x2, _x3, _x4, _x5) {
    return _ref.apply(this, arguments);
  };
}();
const plugin = options => {
  return {
    postcssPlugin: 'postcss-var-url',
    Once(root, helper) {
      const result = helper.result;
      const promises = [];
      const opts = result.opts;
      const from = opts.from ? _path().default.dirname(opts.from) : '.';
      const to = opts.to ? _path().default.dirname(opts.to) : from;
      root.walkDecls(decl => {
        const rs = declProcessor(from, to, options || {}, result, decl);
        promises.push(rs);
      });
      const filename = (0, _cssVar.getFileKey)(opts.from);
      return Promise.all(promises).then(res => {
        const roots = res.filter(v => v !== false);
        if (!roots.length) {
          return;
        }
        const metaObj = {};
        roots.forEach(v => {
          Object.assign(metaObj, v);
        });
        _cssVar.default[filename] = metaObj;
        // fs.writeFileSync(path.resolve(cacheFolder, `${filename}.json`), JSON.stringify(metaObj))
      });
    }
  };
};

plugin.postcss = true;
var _default = exports.default = plugin;