import autoprefixer from 'autoprefixer';
import { PostcssLess2varOptions } from './postcss-plugin-less2var';
import { PostcssVarUrlPluginOptions } from './postcss-plugin-var-url';
/**
 * @link https://www.npmjs.com/package/postcss-pxtorem
 */
export interface RemConfig {
    rootValue: number;
    unitPrecision: number;
    propList: string[];
    selectorBlackList: string[];
    replace: boolean;
    mediaQuery: boolean;
    minPixelValue: number;
    exclude: RegExp;
}
export interface PostCssOptions {
    remEnable: boolean;
    remConfig: Partial<RemConfig>;
    prefixConfig: {
        prefix: Record<string, string>;
        enabled: boolean;
        excludes?: RegExp[];
        includes?: RegExp[];
        test?: (file: string) => boolean;
    };
    less2CssVarConfig: PostcssLess2varOptions & {
        enabled: boolean;
    };
    autoPrefixerOptions?: autoprefixer.Options;
    dynamicCssUrlConfig?: PostcssVarUrlPluginOptions & {
        enabled: boolean;
    };
}
declare const _default: ({ remEnable, remConfig, prefixConfig, less2CssVarConfig, autoPrefixerOptions, dynamicCssUrlConfig, }: PostCssOptions) => {
    sourceMap: boolean;
    postcssOptions: {
        plugins: any[];
    };
};
export default _default;
