"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = transformLessToCss;
function _fs() {
  const data = require("fs");
  _fs = function _fs() {
    return data;
  };
  return data;
}
function _path() {
  const data = _interopRequireDefault(require("path"));
  _path = function _path() {
    return data;
  };
  return data;
}
function _less() {
  const data = _interopRequireDefault(require("less"));
  _less = function _less() {
    return data;
  };
  return data;
}
function _postcss() {
  const data = _interopRequireDefault(require("postcss"));
  _postcss = function _postcss() {
    return data;
  };
  return data;
}
function _lessPluginNpmImport() {
  const data = _interopRequireDefault(require("less-plugin-npm-import"));
  _lessPluginNpmImport = function _lessPluginNpmImport() {
    return data;
  };
  return data;
}
var _getUserConfig = require("./getUserConfig");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }
function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }
function transformLessToCss(_x, _x2) {
  return _transformLessToCss.apply(this, arguments);
}
function _transformLessToCss() {
  _transformLessToCss = _asyncToGenerator(function* (lessFile, config) {
    const resolvedLessFile = _path().default.resolve(config.cwd, lessFile);
    let data = (0, _fs().readFileSync)(resolvedLessFile, 'utf-8');
    data = data.replace(/^\uFEFF/, '');
    // Do less compile
    const lessOpts = {
      paths: [_path().default.dirname(resolvedLessFile)],
      filename: resolvedLessFile,
      plugins: [new (_lessPluginNpmImport().default)({
        prefix: '~'
      })],
      javascriptEnabled: true,
      compress: config.compressStyle !== false
    };
    const result = yield _less().default.render(data, lessOpts);
    const source = result.css;
    const _getPreConfig = (0, _getUserConfig.getPreConfig)(config),
      postcssConfig = _getPreConfig.postcssConfig;
    const r = yield (0, _postcss().default)(postcssConfig.postcssOptions.plugins).process(source, {
      from: lessFile
    });
    return r.css;
  });
  return _transformLessToCss.apply(this, arguments);
}