"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = setFunVersionLoader;
function _loaderUtils() {
  const data = _interopRequireDefault(require("loader-utils"));
  _loaderUtils = function _loaderUtils() {
    return data;
  };
  return data;
}
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function setFunVersionLoader(source) {
  const options = _loaderUtils().default.getOptions(this);
  const d = new Date();
  const internalVersionAnnotation = `
    /**
     * Copyright (c) HopeTop
     *
     * name: ${options.name}
     * version: ${options.version}
     * date: ${d.getFullYear()}-${d.getMonth() + 1}-${d.getDate()} ${d.getHours()}:${d.getMinutes()}:${d.getSeconds()}
     */
  `;
  const dynamicInject = options.dynamicPublicPath ? `__webpack_public_path__ = (window.__REG_ROOT__ || '') + __ASSETS_ROOT__;\n` : '';
  const versionLog = `
    console.log(
      '%c ${options.name} %c ${options.version} %c',
      'background:#35495e; padding: 1px; border-radius: 3px 0 0 3px; color: #fff',
      'background:#228B22; padding: 1px; border-radius: 0 3px 3px 0; color: #fff',
      'background:transparent'
    );`;
  const newSource = `${dynamicInject}${internalVersionAnnotation}\n${versionLog}\n${source}`;
  return `${newSource}`;
}