"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
function _webpack() {
  const data = require("webpack");
  _webpack = function _webpack() {
    return data;
  };
  return data;
}
class FilePathInAssetPlugin {
  constructor(config) {
    this.config = void 0;
    this.config = config;
  }
  apply(compiler) {
    let _this$config = this.config,
      _this$config$pathInJs = _this$config.pathInJs,
      pathInJs = _this$config$pathInJs === void 0 ? '' : _this$config$pathInJs,
      _this$config$pathInCs = _this$config.pathInCss,
      pathInCss = _this$config$pathInCs === void 0 ? '' : _this$config$pathInCs,
      _this$config$placehol = _this$config.placeholder,
      placeholder = _this$config$placehol === void 0 ? '' : _this$config$placehol,
      dynamicPublicPath = _this$config.dynamicPublicPath;
    if (placeholder.length === 0) {
      throw new Error('参数 placeholder 不予许为空');
    }
    if (pathInJs.lastIndexOf('/') === pathInJs.length - 1) {
      pathInJs = pathInJs.substring(0, pathInJs.length - 1);
    }
    if (pathInCss.lastIndexOf('/') === pathInCss.length - 1) {
      pathInCss = pathInCss.substring(0, pathInCss.length - 1);
    }
    const reg = new RegExp(placeholder.replace('[', '\\[').replace(']', '\\]/.?'), 'g');
    const reg2 = !dynamicPublicPath ? reg : new RegExp(`['"]` + placeholder.replace('[', '\\[').replace(']', '\\]/.?'), 'g');
    pathInJs = !dynamicPublicPath ? pathInJs : '(window.__REG_ROOT__ || "")+"' + pathInJs;
    compiler.hooks.make.tap('FilePathInAssetPlugin', compilation => {
      if (compilation.outputOptions.library.type !== 'umd') {
        return;
      }
      compilation.hooks.processAssets.tap({
        name: 'FilePathInAssetPlugin',
        stage: _webpack().Compilation.PROCESS_ASSETS_STAGE_ANALYSE,
        additionalAssets: true
      }, assets => {
        let keys = Object.keys(assets);
        keys.forEach(key => {
          const asset = assets[key];
          if (key.indexOf('.js') > 0) {
            compilation.updateAsset(key, new (_webpack().sources.RawSource)(asset.source().toString().replace(reg2, pathInJs)));
          } else if (key.indexOf('.css') > 0) {
            compilation.updateAsset(key, new (_webpack().sources.RawSource)(asset.source().toString().replace(reg, pathInCss)));
          }
        });
      });
    });
  }
}
exports.default = FilePathInAssetPlugin;