"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
function _ModuleDependencyWarning() {
  const data = _interopRequireDefault(require("webpack/lib/ModuleDependencyWarning"));
  _ModuleDependencyWarning = function _ModuleDependencyWarning() {
    return data;
  };
  return data;
}
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
class IgnoreNotFoundExportPlugin {
  apply(compiler) {
    const messageRegExp = /export '.*'( \(reexported as '.*'\))? was not found in/;
    function doneHook(stats) {
      stats.compilation.warnings = stats.compilation.warnings.filter(function (warn) {
        return !(warn instanceof _ModuleDependencyWarning().default && messageRegExp.test(warn.message));
      });
    }
    compiler.hooks.done.tap('IgnoreNotFoundExportPlugin', doneHook);
  }
}
exports.default = IgnoreNotFoundExportPlugin;