"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
function _webpack() {
  const data = require("webpack");
  _webpack = function _webpack() {
    return data;
  };
  return data;
}
class UmdNoDojoAmdPlugin {
  apply(compiler) {
    compiler.hooks.make.tap('UmdNoDojoAmdPlugin', compilation => {
      if (compilation.outputOptions.library.type !== 'umd') {
        return;
      }
      compilation.hooks.processAssets.tap({
        name: 'UmdNoDojoAmdPlugin',
        stage: _webpack().Compilation.PROCESS_ASSETS_STAGE_ANALYSE,
        additionalAssets: true
      }, assets => {
        Object.keys(assets).filter(key => /\.js$/i.test(key)).forEach(key => {
          const asset = assets[key];
          compilation.updateAsset(key, new (_webpack().sources.RawSource)(asset.source().toString().replace('define.amd', 'define.amd && define.amd.vendor !== \'dojotoolkit.org\'')));
        });
      });
    });
  }
}
exports.default = UmdNoDojoAmdPlugin;