"use strict";

function _path() {
  const data = _interopRequireDefault(require("path"));
  _path = function _path() {
    return data;
  };
  return data;
}
function _fs() {
  const data = _interopRequireDefault(require("fs"));
  _fs = function _fs() {
    return data;
  };
  return data;
}
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
const postcss = require('postcss');
const syntax = require('postcss-less');
const utils = require('loader-utils');
const __LINE__ = '\n';
module.exports = function () {
  const options = utils.getOptions(this) || {};
  const callback = this.async();
  const resourcePath = this.resourcePath;
  const contextPath = this.rootContext;
  const basePath = _path().default.resolve(contextPath, options.basePath || './');
  const globalImports = [];
  const mappings = _objectSpread({}, options.mappings);
  const content = compile({
    resourcePath,
    nodeModulesPath: _path().default.resolve(process.cwd(), './node_modules'),
    contextPath: basePath
  }, options.imports === true, [], mappings);
  postcss(options.plugins).process(globalImports.join(__LINE__) + __LINE__ + content, {
    syntax,
    from: resourcePath
  }).then(res => callback(null, res.content, res.map)).catch(e => callback(e));
};
/**
 * 合并多个less
 * @param options
 * @param imports
 * @param globalImports
 * @param mappings
 * @returns {string}
 */
function compile(options, imports = false, globalImports = [], mappings = {}) {
  const cache = {};
  function combineLess(options) {
    const resourcePath = options.resourcePath,
      contextPath = options.contextPath,
      nodeModulesPath = options.nodeModulesPath;
    const fileContent = _fs().default.readFileSync(resourcePath).toString();
    const directory = _path().default.dirname(resourcePath);
    const res = fileContent.split(__LINE__).map(line => {
      const tr = line.trim();
      if (/^$|^\/\//.test(tr)) {
        return '';
      }
      if (!line.startsWith('@import')) {
        return line;
      }
      let importPath = line.match(/@import\ ["'](.*)["'];/)[1];
      if (!importPath.endsWith('.less')) {
        importPath += '.less';
      }
      const isFromNodeModules = /^~/.test(importPath);
      let normalizedImportPath = isFromNodeModules ? importPath.slice(1) : importPath;
      const newPath = _path().default.join(isFromNodeModules ? nodeModulesPath : directory, normalizedImportPath);
      const relPath = isFromNodeModules ? importPath : _path().default.relative(contextPath, newPath);
      const mapKey = relPath.replace(/[\/\\]+/g, '/');
      let impPath = mappings[mapKey];
      if (cache[newPath]) {
        return '';
      }
      cache[newPath] = true;
      const mapped = typeof impPath !== 'undefined' && impPath !== null;
      if (!mapped) {
        return combineLess({
          contextPath,
          resourcePath: newPath,
          nodeModulesPath
        });
      }
      if (!imports) {
        return '';
      }
      if (isFromNodeModules) {
        if (typeof impPath === 'function') {
          impPath = impPath(importPath);
        }
        if (!impPath) {
          return '';
        }
        globalImports.push(`@import "/${impPath.replace(/^\//, '')}";`);
        return '';
      }
      if (typeof impPath === 'function') {
        impPath = impPath(importPath);
      }
      if (!impPath) {
        return '';
      }
      globalImports.push(`@import "${impPath}";`);
      return '';
    });
    return res.filter(Boolean).join(__LINE__);
  }
  return combineLess(options);
}