"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = generateChangeLog;
function _conventionalChangelog() {
  const data = _interopRequireDefault(require("conventional-changelog"));
  _conventionalChangelog = function _conventionalChangelog() {
    return data;
  };
  return data;
}
function _fs() {
  const data = _interopRequireDefault(require("fs"));
  _fs = function _fs() {
    return data;
  };
  return data;
}
function _path() {
  const data = _interopRequireDefault(require("path"));
  _path = function _path() {
    return data;
  };
  return data;
}
var _log = require("../log");
var _printLog = require("../utils/printLog");
const _excluded = ["verbose"];
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
function generateChangeLog(options = {}) {
  const projectDir = process.cwd();
  const verbose = options.verbose,
    commitOpts = _objectWithoutProperties(options, _excluded);
  // eslint-disable-next-line @typescript-eslint/no-require-imports
  const pkgPath = require(_path().default.join(projectDir, 'package.json'));
  if (_fs().default.existsSync(pkgPath)) {
    if (verbose) {
      (0, _log.error)('未发现package信息');
    }
    return;
  }
  const stream = _fs().default.createWriteStream(_path().default.resolve(projectDir, 'CHANGELOG.MD'), {
    flags: 'w+'
  });
  stream.on('close', () => {
    if (verbose) {
      (0, _printLog.info)('ChangeLog 生成完成！');
    }
  });
  (0, _conventionalChangelog().default)({
    config: {
      parserOpts: {},
      writerOpts: {
        transform(options, callback) {
          // console.log(options);
          return options;
        }
      }
    },
    append: true,
    transform: (options, callback) => {
      options.header = options.header.replace(/\b(bug|story)~(\d{1,10})/g, '[$1#$2](http://114.215.149.146:81/zentaopms/www/$1-view-$2.html)');
      callback(null, options);
    }
  }, _objectSpread({
    commit: 'commit'
  }, commitOpts), {}).pipe(stream);
}