"use strict";

function _path() {
  const data = _interopRequireDefault(require("path"));
  _path = function _path() {
    return data;
  };
  return data;
}
function _child_process() {
  const data = require("child_process");
  _child_process = function _child_process() {
    return data;
  };
  return data;
}
var _utils = require("../utils");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function checkState() {
  const a = (0, _child_process().execSync)('git status --porcelain');
  const result = a.toString();
  if (/^\?\?/m.test(result)) {
    _utils.printLog.error(`There are untracked files in the working tree.\n${result}`);
    return 1;
  }
  return 0;
}
function tag(version) {
  _utils.printLog.info('tagging');
  _utils.printLog.info(`Current npm project version: ${version}`);
  (0, _child_process().execSync)(`git tag -a ${version} -m ${version}`);
  (0, _child_process().execSync)(`git push origin ${version}:${version}`);
  (0, _child_process().execSync)('git push origin master:master');
  _utils.printLog.info('tagged');
}
const cwd = process.cwd();
process.exit(0);
const result = checkState();
if (result === 1) {
  process.exit(1);
} else {
  const pkg = require(_path().default.resolve(cwd, 'package.json'));
  tag(pkg.version);
}