"use strict";

function _path() {
  const data = _interopRequireDefault(require("path"));
  _path = function _path() {
    return data;
  };
  return data;
}
function _fs() {
  const data = _interopRequireDefault(require("fs"));
  _fs = function _fs() {
    return data;
  };
  return data;
}
function _chalk() {
  const data = _interopRequireDefault(require("chalk"));
  _chalk = function _chalk() {
    return data;
  };
  return data;
}
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function reportNoConfig() {
  console.log(_chalk().default.bgRed('!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'));
  console.log(_chalk().default.bgRed('!! 当前 npm 工程缺失 package.json 文件 !!'));
  console.log(_chalk().default.bgRed('!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'));
}
function reportCompletion() {
  console.log(_chalk().default.bgGreen('!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'));
  console.log(_chalk().default.bgGreen('!! pipenet-tools 安装完成，在使用前，请先配置 /config/config.js 文件 !!'));
  console.log(_chalk().default.bgGreen('!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'));
}
function addConfigHooks(cfg, projectDir) {
  if (!cfg.scripts) {
    cfg.scripts = {};
  }
  cfg.scripts = Object.assign(cfg.scripts, {
    dev: 'pipenet-tools dev',
    build: 'pipenet-tools build',
    log: 'pipenet-tools log',
    lint: 'eslint --ext .js,.jsx,.ts,.tsx src',
    'lint:fix': 'eslint --ext .js,.jsx,.ts,.tsx src --fix',
    prettier: 'prettier --write **/*.{js,jsx,tsx,ts,less,md,json}',
    test: 'pipenet-tools test',
    'test:coverage': 'pipenet-tools test --coverage'
  });
  _fs().default.writeFileSync(_path().default.join(projectDir, 'package.json'), JSON.stringify(cfg, null, 2));
  return true;
}
function init() {
  const projectDir = process.cwd();
  // eslint-disable-next-line @typescript-eslint/no-require-imports
  const cfg = require(_path().default.join(projectDir, 'package.json'));
  initTemplates();
  if (!cfg) {
    reportNoConfig();
    process.exit(1);
  } else if (addConfigHooks(cfg, projectDir)) {
    reportCompletion();
  }
}
function initTemplates() {
  const projectDir = process.cwd();
  // 生成 babel.config.js webpack.js
  // const babelConfigPath = path.resolve(projectDir, 'babel.config.js');
  // const webpackConfigPath = path.resolve(projectDir, 'webpack.config.js');
  // if (!existsSync(babelConfigPath)) {
  //   fs.copyFileSync(path.resolve(__dirname, '../../template/babel.config.js'), babelConfigPath);
  // }
  // if (!existsSync(webpackConfigPath)) {
  //   fs.copyFileSync(path.resolve(__dirname, '../../template/babel.config.js'), webpackConfigPath);
  // }
}

init();