"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.check = check;
exports.install = install;
function _fsExtra() {
  const data = require("fs-extra");
  _fsExtra = function _fsExtra() {
    return data;
  };
  return data;
}
function _path() {
  const data = require("path");
  _path = function _path() {
    return data;
  };
  return data;
}
function _chalk() {
  const data = _interopRequireDefault(require("chalk"));
  _chalk = function _chalk() {
    return data;
  };
  return data;
}
function _child_process() {
  const data = require("child_process");
  _child_process = function _child_process() {
    return data;
  };
  return data;
}
function _os() {
  const data = require("os");
  _os = function _os() {
    return data;
  };
  return data;
}
function _prettier() {
  const data = _interopRequireDefault(require("prettier"));
  _prettier = function _prettier() {
    return data;
  };
  return data;
}
var _log = require("../log");
function _stagedGitFiles() {
  const data = _interopRequireDefault(require("staged-git-files"));
  _stagedGitFiles = function _stagedGitFiles() {
    return data;
  };
  return data;
}
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }
function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }
const HOOK_MARK = '##### CREATED BY PIPENET-TOOLS #####';
const PRETTIER_PARSER = {
  js: 'babel',
  jsx: 'babel',
  ts: 'typescript',
  tsx: 'typescript'
};
const cwd = process.cwd();
// TODO: 支持从 userConfig 中获取
const preCommitConfig = {
  prettier: true,
  eslint: true
};
function getPreCommitTemplate() {
  return ['#!/usr/bin/env bash', 'npx pipenet-tools pre-commit', 'RESULT=$?', '[ $RESULT -ne 0 ] && exit 1', 'exit 0', HOOK_MARK].join(_os().EOL);
}
function install() {
  const usePreCommit = !!Object.keys(preCommitConfig).length;
  const hookPath = (0, _path().join)(cwd, '.git/hooks');
  const preCommitHooks = (0, _path().join)(hookPath, 'pre-commit');
  const existHooks = (0, _fsExtra().existsSync)(preCommitHooks);
  const isPipenetPreCommit = existHooks && (0, _fsExtra().readFileSync)(preCommitHooks, 'utf8').includes(HOOK_MARK);
  // Check if exist other hooks
  if (usePreCommit && existHooks && !isPipenetPreCommit) {
    (0, _log.warn)('Another pre-commit hooks is in using. Father pre-commit hook will not work.');
    return;
  }
  if (usePreCommit && !existHooks) {
    // Create hook path
    (0, _fsExtra().ensureDirSync)(hookPath);
    (0, _fsExtra().writeFileSync)(preCommitHooks, getPreCommitTemplate(), 'utf8');
    try {
      (0, _fsExtra().chmodSync)(preCommitHooks, '777');
    } catch (e) {
      (0, _log.warn)(`chmod ${_chalk().default.cyan(preCommitHooks)} failed: ${e.message}`);
    }
    (0, _log.log)('Create pre-commit hook');
  }
}
function runCmd(cmd, args) {
  return new Promise((resolve, reject) => {
    args = args || [];
    const runner = (0, _child_process().spawn)(cmd, args, {
      // keep color
      stdio: 'inherit'
      // shell: true,
    });

    runner.on('close', code => {
      if (code) {
        (0, _log.error)(`Error on execution: ${cmd} ${(args || []).join(' ')}`);
        reject(code);
        return;
      }
      resolve(null);
    });
  });
}
function getPrettierConfig() {
  const prettierrcPath = (0, _path().join)(cwd, '.prettierrc');
  if ((0, _fsExtra().existsSync)(prettierrcPath)) {
    return JSON.parse((0, _fsExtra().readFileSync)(prettierrcPath, 'utf-8')) || {};
  } else {
    const templateConfig = require('../defaultConfig/prettier');
    return templateConfig;
  }
}
function getEsLintConfigPath() {
  const lintPath = (0, _path().join)(cwd, '.eslintrc.js');
  if ((0, _fsExtra().existsSync)(lintPath)) {
    return lintPath;
  } else {
    const templateLintPath = require.resolve('../defaultConfig/eslint.ts');
    return templateLintPath;
  }
}
function check() {
  return _check.apply(this, arguments);
}
function _check() {
  _check = _asyncToGenerator(function* () {
    const list = (yield (0, _stagedGitFiles().default)()).map(file => file.filename).filter(filename => /^(src|tests|examples)/.test(filename)).filter(filename => /\.(ts|js|tsx|jsx)$/.test(filename))
    // Only keep exist files
    .map(filename => {
      const filePath = (0, _path().join)(cwd, filename);
      return (0, _fsExtra().existsSync)(filePath) ? filePath : null;
    }).filter(filePath => filePath);
    if (!list.length) {
      return;
    }
    // Prettier
    if (preCommitConfig.prettier) {
      const prettierConfig = getPrettierConfig();
      list.forEach(filePath => {
        if ((0, _fsExtra().existsSync)(filePath)) {
          const ext = (0, _path().extname)(filePath).replace(/^\./, '');
          const text = (0, _fsExtra().readFileSync)(filePath, 'utf8');
          const formatText = _prettier().default.format(text, _objectSpread({
            parser: PRETTIER_PARSER[ext]
          }, prettierConfig));
          (0, _fsExtra().writeFileSync)(filePath, formatText, 'utf8');
        }
      });
      (0, _log.log)(`${_chalk().default.cyan('prettier')} success!`);
    }
    // eslint
    if (preCommitConfig.eslint) {
      const eslintConfigPath = getEsLintConfigPath();
      const eslintBin = require.resolve('eslint/bin/eslint');
      const args = [eslintBin, '-c', eslintConfigPath, ...list, '--fix'];
      try {
        yield runCmd('node', args);
      } catch (code) {
        process.exit(code);
      }
      (0, _log.log)(`${_chalk().default.cyan('eslint')} success!`);
    }
    yield runCmd('git', ['add', ...list]);
  });
  return _check.apply(this, arguments);
}