"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;
function _path() {
  const data = require("path");
  _path = function _path() {
    return data;
  };
  return data;
}
function _fs() {
  const data = require("fs");
  _fs = function _fs() {
    return data;
  };
  return data;
}
function _args() {
  const data = require("jest-cli/build/cli/args");
  _args = function _args() {
    return data;
  };
  return data;
}
function _assert() {
  const data = _interopRequireDefault(require("assert"));
  _assert = function _assert() {
    return data;
  };
  return data;
}
var _utils = require("../utils");
var _createDefaultConfig = _interopRequireDefault(require("./createDefaultConfig/createDefaultConfig"));
function _jest() {
  const data = require("jest");
  _jest = function _jest() {
    return data;
  };
  return data;
}
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }
function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }
const debug = (0, _utils.createDebug)('ppt:test');
function _default(_x) {
  return _ref.apply(this, arguments);
}
function _ref() {
  _ref = _asyncToGenerator(function* (args) {
    process.env.NODE_ENV = 'test';
    if (args.debug) {
      _utils.createDebug.enable('ppt:test');
    }
    debug(`args: ${JSON.stringify(args)}`);
    const cwd = args.cwd || process.cwd();
    // Read config from ${cwd}/jest.config.js
    const userJestConfigFile = (0, _path().join)(cwd, 'jest.config.js');
    const userJestConfig = (0, _fs().existsSync)(userJestConfigFile) && require(userJestConfigFile);
    debug(`config from jest.config.js: ${JSON.stringify(userJestConfig)}`);
    // Read jest config from package.json
    const packageJSONPath = (0, _path().join)(cwd, 'package.json');
    const packageJestConfig = (0, _fs().existsSync)(packageJSONPath) && require(packageJSONPath).jest;
    debug(`jest config from package.json: ${JSON.stringify(packageJestConfig)}`);
    // Merge configs
    const config = (0, _utils.mergeConfig)((0, _createDefaultConfig.default)(cwd, args), packageJestConfig, userJestConfig);
    debug(`final config: ${JSON.stringify(config)}`);
    // Generate jest options
    const argsConfig = Object.keys(_args().options).reduce((prev, name) => {
      if (args[name]) {
        prev[name] = name;
      }
      // Convert alias args into real one
      const alias = _args().options[name].alias;
      if (alias && args[alias]) {
        prev[name] = args[alias];
      }
      return prev;
    }, {});
    debug(`config from args: ${JSON.stringify(argsConfig)}`);
    // Run jest
    const result = yield (0, _jest().runCLI)(_objectSpread({
      // @ts-ignore
      _: args._ || [],
      // @ts-ignore
      $0: args.$0 || '',
      // 必须是单独的 config 配置，值为 string，否则不生效
      // @ts-ignore
      config: JSON.stringify(config)
    }, argsConfig), [cwd]);
    debug(result);
    // Throw error when run failed
    (0, _assert().default)(result.results.success, `Test with jest failed`);
  });
  return _ref.apply(this, arguments);
}