"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.compileLess = compileLess;
exports.compileLess2 = compileLess2;
exports.copyPublic = copyPublic;
exports.dist = dist;
exports.getFinalWebpackConfig = getFinalWebpackConfig;
function _path() {
  const data = _interopRequireDefault(require("path"));
  _path = function _path() {
    return data;
  };
  return data;
}
function _gulp() {
  const data = _interopRequireDefault(require("gulp"));
  _gulp = function _gulp() {
    return data;
  };
  return data;
}
function _through() {
  const data = _interopRequireDefault(require("through2"));
  _through = function _through() {
    return data;
  };
  return data;
}
function _webpack() {
  const data = _interopRequireDefault(require("webpack"));
  _webpack = function _webpack() {
    return data;
  };
  return data;
}
var _getWebpackConfig = _interopRequireDefault(require("../common/getWebpackConfig"));
var _transformLessToCss = _interopRequireDefault(require("../common/transformLessToCss"));
var _transformLessToLess = _interopRequireWildcard(require("../common/transformLessToLess"));
var _nav = require("./nav");
var _pathConfig = _interopRequireDefault(require("../common/pathConfig"));
var _log = require("../log");
function _fs() {
  const data = require("fs");
  _fs = function _fs() {
    return data;
  };
  return data;
}
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && Object.prototype.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
function compileLess2(userConfig, callback) {
  const absDir = userConfig.absDir,
    toLess = userConfig.toLess,
    entryStyle = userConfig.entryStyle,
    useRem = userConfig.useRem,
    remConfig = userConfig.remConfig;
  const entries = Object.entries(entryStyle);
  if (toLess) {
    lessNext(entries, 0, () => {
      (0, _log.log)('less is ok');
      if (typeof callback === 'function') {
        callback();
      }
    });
  } else {
    cssNext(entries, 0, () => {
      (0, _log.log)('css is ok');
      if (typeof callback === 'function') {
        callback();
      }
    });
  }
  function lessNext(entries, index, callback) {
    if (entries.length === index) {
      if (typeof callback === 'function') {
        callback();
      }
      return;
    }
    const _entries$index = _slicedToArray(entries[index], 2),
      targetPath = _entries$index[0],
      sourcePath = _entries$index[1];
    const targetFilePath = _path().default.resolve(absDir, targetPath + '.less');
    const targetFolder = _path().default.dirname(targetFilePath);
    const filePath = _path().default.resolve(_pathConfig.default.cwd, sourcePath);
    (0, _log.log)(targetFilePath);
    (0, _log.log)(filePath);
    mkdirsSync(targetFolder);
    (0, _transformLessToLess.default)(filePath, userConfig).then(less => {
      (0, _log.log)(less.length);
      (0, _fs().writeFile)(targetFilePath, less, err => {
        if (err) {
          (0, _log.error)(err);
        }
        (0, _log.log)('less write success');
        (0, _log.log)('--------------');
        lessNext(entries, index + 1, callback);
      });
    }, err => {
      if (err) {
        (0, _log.error)(err);
      }
      (0, _log.log)('--------------');
      lessNext(entries, index + 1, callback);
    });
  }
  function cssNext(entries, index, callback) {
    if (entries.length === index) {
      if (typeof callback === 'function') {
        callback();
      }
      return;
    }
    const _entries$index2 = _slicedToArray(entries[index], 2),
      targetPath = _entries$index2[0],
      sourcePath = _entries$index2[1];
    const targetFilePath = _path().default.resolve(_pathConfig.default.cwd, absDir, targetPath + '.css');
    const targetFolder = _path().default.dirname(targetFilePath);
    const filePath = _path().default.resolve(_pathConfig.default.cwd, sourcePath);
    mkdirsSync(targetFolder);
    (0, _transformLessToCss.default)(filePath, userConfig).then(css => {
      (0, _fs().writeFile)(targetFilePath, css, err => {
        if (err) {
          (0, _log.error)(err);
        }
        (0, _log.log)('css write success');
        (0, _log.log)('--------------');
        cssNext(entries, index + 1, callback);
      });
    });
  }
  function mkdirsSync(dirname) {
    // console.log(dirname);
    if ((0, _fs().existsSync)(dirname)) {
      return true;
    } else {
      if (mkdirsSync(_path().default.dirname(dirname))) {
        (0, _fs().mkdirSync)(dirname);
        return true;
      }
    }
  }
}
function compileLess(userConfig, callback) {
  const absDir = userConfig.absDir;
  const lessPath = (0, _nav.getLessPath)(userConfig);
  (0, _log.log)(lessPath);
  let fireCount = 0;
  const distCount = userConfig.toLess ? userConfig.withCss ? 2 : 1 : 1;
  const end = () => {
    if (fireCount >= distCount) {
      callback === null || callback === void 0 ? void 0 : callback();
      return;
    }
    fireCount++;
  };
  const pipe = (toLess = false, combine = false) => {
    return function (chunk, encoding, next) {
      if (toLess) {
        (0, _transformLessToLess.default)(chunk.path, userConfig).then(less => {
          chunk.contents = Buffer.from(less);
          // TODO 这部分原理明日处理
          chunk.path = chunk.path.replace('layouts', `layouts/layouts`);
          this.push(chunk);
          next();
        }).catch(e => {
          (0, _log.error)(e);
        });
      } else {
        const handle = combine ? _transformLessToLess.transformCombineLess2css : _transformLessToCss.default;
        handle(chunk.path, userConfig).then(css => {
          chunk.contents = Buffer.from(css);
          // TODO 这部分原理明日处理
          chunk.path = chunk.path.replace('layouts', `layouts/layouts`);
          chunk.path = chunk.path.replace(/\.less$/, '.css');
          this.push(chunk);
          next();
        }).catch(e => {
          (0, _log.error)(e);
        });
      }
    };
  };
  const createLessStream = () => _gulp().default.src(lessPath).pipe(_through().default.obj(pipe(true))).pipe(_gulp().default.dest(absDir)).on('end', end);
  const createCssStream = () => _gulp().default.src(lessPath).pipe(_through().default.obj(pipe(false, true))).pipe(_gulp().default.dest(absDir)).on('end', end);
  if (userConfig.toLess) {
    if (userConfig.withCss) {
      createCssStream();
    }
    return createLessStream();
  }
  return _gulp().default.src(lessPath).pipe(_through().default.obj(pipe(false))).pipe(_gulp().default.dest(absDir)).on('end', () => {
    callback === null || callback === void 0 ? void 0 : callback();
  });
}
function copyPublic(userConfig) {
  const src = _path().default.resolve(_pathConfig.default.cwd, 'public', '**', '*');
  _gulp().default.src(src).pipe(_gulp().default.dest(userConfig.absDir));
}
function getFinalWebpackConfig(userConfig, cache = true) {
  const cwd = userConfig.cwd,
    entryFromUserConfig = userConfig.entry,
    projectName = userConfig.projectName,
    scan = userConfig.scan,
    absDir = userConfig.absDir,
    routerIndex = userConfig.routerIndex,
    mode = userConfig.mode,
    pkg = userConfig.pkg;
  let functionPath = '';
  let publicPath = '';
  let entry = {};
  const secondLevelFolders = {};
  if (entryFromUserConfig) {
    entry = entryFromUserConfig;
  } else {
    if (routerIndex) {
      (0, _log.log)('routerIndex 模式');
      const routeEntry = scan[0];
      if (!routeEntry) {
        (0, _log.log)('在 routerIndex 模式下，不存在 src/router.js 或者 src/router.ts');
        process.exit(1);
      }
      let file = _path().default.resolve(cwd, 'src', routeEntry);
      if (!(0, _fs().existsSync)(file)) {
        (0, _log.log)(`在 routerIndex 模式下， 入口src/${routeEntry}不存在`);
        process.exit(1);
      }
      const withVersion = process.env.WITH_VERSION === 'true';
      if (mode === 'development' && !withVersion) {
        functionPath = _path().default.resolve(absDir, 'pages', projectName);
        publicPath = '/capsule/pages/' + projectName + '/';
      } else {
        const projectNameWithVersion = projectName + '@' + pkg.version;
        functionPath = _path().default.resolve(absDir, 'pages', projectNameWithVersion);
        publicPath = '/capsule/pages/' + projectNameWithVersion + '/';
      }
      // const projectNameWithVersion = projectName + '@' + pkg.version;
      // functionPath = path.resolve(absDir, 'pages', projectNameWithVersion);
      // publicPath = '/capsule/pages/' + projectNameWithVersion + '/';
      entry[`./index`] = file;
    } else {
      (0, _log.log)('scan 模式');
      const files = (0, _nav.getJsFiles)(userConfig);
      (0, _log.log)('获取到的待打包文件如下：');
      (0, _log.log)(files);
      files.forEach(file => {
        const lastIndex = file.lastIndexOf('.');
        if (file.indexOf('/pages/') !== -1) {
          functionPath = _path().default.resolve(absDir, 'pages', projectName);
          publicPath = '/capsule/pages/' + projectName + '/';
          const fileKey = file.substring(file.indexOf('/pages/') + 7, lastIndex);
          entry[`./${fileKey}`] = file;
          secondLevelFolders['pages'] = true;
        } else if (file.indexOf('/common/2.x/') !== -1) {
          functionPath = _path().default.resolve(absDir, 'pages', projectName);
          publicPath = '/capsule/pages/' + projectName + '/';
          const fileKey = file.substring(file.indexOf('/common/2.x/') + 12, lastIndex);
          entry[`./${fileKey}`] = file;
          secondLevelFolders[`/pages/${projectName}`] = true;
        } else if (file.indexOf('/components/') !== -1) {
          const fileKey = file.substring(file.indexOf('/components/'), lastIndex);
          entry[`/${fileKey}`] = file;
          secondLevelFolders['components'] = true;
        } else if (file.indexOf('/layouts/') !== -1) {
          const fileKey = file.substring(file.indexOf('/layouts/'), lastIndex);
          entry[`/${fileKey}`] = file;
          secondLevelFolders['layouts'] = true;
        } else if (file.indexOf('/factory/') !== -1) {
          const fileKey = file.substring(file.indexOf('/factory/'), lastIndex);
          entry[`/layouts/${fileKey}`] = file;
          secondLevelFolders['layouts'] = true;
        }
      });
    }
  }
  (0, _log.log)('获取到的 webpack.entry 属性如下：');
  (0, _log.log)(entry);
  if (Object.keys(entry).length === 0) {
    (0, _log.error)('不存在可用的 index.js');
    process.exit(1);
  }
  let webpackConfig = (0, _getWebpackConfig.default)(userConfig, cache);
  webpackConfig = _objectSpread(_objectSpread({}, webpackConfig), {}, {
    entry
  });
  if (functionPath.length > 0) {
    webpackConfig.output.path = functionPath;
  }
  if (publicPath.length > 0) {
    webpackConfig.output.publicPath = publicPath;
  }
  return webpackConfig;
}
function dist(userConfig, done) {
  const webpackConfig = getFinalWebpackConfig(userConfig);
  (0, _log.log)('webpack 打包--开始');
  return (0, _webpack().default)(webpackConfig, (err, stats) => {
    (0, _log.log)('webpack 打包--完成');
    done === null || done === void 0 ? void 0 : done(err);
    if (err) {
      (0, _log.error)(err.stack || err);
      return;
    }
    if (stats.hasErrors() || stats.hasWarnings()) {
      (0, _log.error)(stats.toString(_objectSpread({
        all: false,
        version: true,
        timings: true,
        modules: false,
        modulesSpace: 0,
        assets: false,
        assetsSpace: 0,
        errors: true,
        errorsCount: true,
        warnings: true,
        warningsCount: true,
        logging: 'warn'
      }, userConfig.stats)));
    }
  });
}