type AnyConfig<T extends Record<string, any>, U extends Record<string, any>> = {
    [V in keyof U]: V extends keyof T ? (U[V] extends (...args: any[]) => any ? (argv: T[V]) => T[V] : T[V]) : U[V];
};
type CalculatedConfig<T extends Record<string, any>, U extends Record<string, any>> = T & {
    [V in keyof U]: V extends keyof T ? T[V] : U[V];
};
/**
 * 递归合并，碰到相同的属性，后者会直接替换前者，“值”不会再合并
 * @param defaultConfig
 * @param configs
 */
export default function mergeConfig<T extends Record<string, any>, U extends Record<string, any>>(defaultConfig: T, ...configs: (AnyConfig<T, U> | null | undefined)[]): CalculatedConfig<T, U>;
export {};
