"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getAssetsPath = getAssetsPath;
exports.getJsFiles = getJsFiles;
exports.getLessPath = getLessPath;
function _lodash() {
  const data = require("lodash");
  _lodash = function _lodash() {
    return data;
  };
  return data;
}
function _path() {
  const data = require("path");
  _path = function _path() {
    return data;
  };
  return data;
}
function _globby() {
  const data = _interopRequireDefault(require("globby"));
  _globby = function _globby() {
    return data;
  };
  return data;
}
var _log = require("../log");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function getAssetsPath(userConfig) {
  const scan = userConfig.scan,
    base = userConfig.base;
  if (Array.isArray(scan)) {
    return (0, _path().resolve)(base, `+(${scan.join('|')})`, '**', '*.@(png|svg');
  } else if ((0, _lodash().isPlainObject)(scan) && typeof scan.asset === 'string' && scan.asset.length > 0) {
    return `${base}/${scan.asset}`.replace('//', '/');
  }
  return '';
}
function getLessPath(userConfig) {
  const scanLess = userConfig.scanLess,
    baseLess = userConfig.baseLess,
    _userConfig$scanFiles = userConfig.scanFiles,
    scanFiles = _userConfig$scanFiles === void 0 ? ['index'] : _userConfig$scanFiles;
  if (Array.isArray(scanLess)) {
    const nextScan = scanLess.filter(v => !/\.less$/i.test(v));
    const nextScan2 = scanLess.filter(v => /\.less$/i.test(v));
    if (scanLess.length > 0) {
      const m1 = nextScan.length > 0 ? [(0, _path().resolve)(baseLess, `+(${nextScan.join('|')})`, 'style', `+(${scanFiles.join('|')}).less`)] : [];
      const m2 = nextScan2.map(v => (0, _path().resolve)(baseLess, v));
      return [...m1, ...m2];
    }
    return (0, _path().resolve)(baseLess, '**', 'style', 'index.less');
  }
  return '';
}
function getJsFiles(userConfig) {
  const scan = userConfig.scan,
    base = userConfig.base;
  let files = [];
  if (Array.isArray(scan)) {
    scan.forEach(fileUrl => {
      if (fileUrl.lastIndexOf('.') === -1) {
        const pattern = `${base}/${fileUrl}/**/index.+(js|jsx|ts|tsx)`.replace('//', '/');
        (0, _log.log)(pattern);
        const tmpFiles = _globby().default.sync(pattern);
        (0, _log.log)(tmpFiles);
        files = files.concat(tmpFiles);
      } else {
        const file = `${base}/${fileUrl}`.replace('//', '/');
        files.push(file); // path.resolve(base, fileUrl);
      }
    });
  } else if ((0, _lodash().isPlainObject)(scan) && typeof scan.js === 'string' && scan.js.length > 0) {
    // return `${base}/${scan.js}`.replace('//', '/');
    const pattern = `${base}/${scan.js}`.replace('//', '/');
    files = _globby().default.sync(pattern);
  }
  return files;
}