"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.compileExp = void 0;
exports.createZip = createZip;
exports.default = void 0;
exports.pack = pack;
function _fs() {
  const data = _interopRequireWildcard(require("fs"));
  _fs = function _fs() {
    return data;
  };
  return data;
}
function _path() {
  const data = _interopRequireDefault(require("path"));
  _path = function _path() {
    return data;
  };
  return data;
}
function _archiver() {
  const data = _interopRequireDefault(require("archiver"));
  _archiver = function _archiver() {
    return data;
  };
  return data;
}
function _chalk() {
  const data = _interopRequireDefault(require("chalk"));
  _chalk = function _chalk() {
    return data;
  };
  return data;
}
function _filesize() {
  const data = require("filesize");
  _filesize = function _filesize() {
    return data;
  };
  return data;
}
var _getUserConfig = _interopRequireDefault(require("../common/getUserConfig"));
const _excluded = ["file", "outDir"];
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && Object.prototype.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
const logger = console;
function createZip(options, callback) {
  const exportFile = options.exportFile,
    basePath = options.basePath,
    fileList = options.fileList,
    excludeDirs = options.excludeDirs,
    excludes = options.excludes;
  const output = (0, _fs().createWriteStream)(exportFile);
  const archive = (0, _archiver().default)('zip', {
    zlib: {
      level: 9
    }
  });
  const filtersCreator = excludes => excludes.map(v => typeof v === 'function' ? v : x => (typeof v === 'string' ? new RegExp(v) : v).test(x));
  const excludeDirFilters = filtersCreator([...(excludeDirs || []), /(node_modules|\.\w+)/]);
  const excludeFilters = filtersCreator(excludes || []);
  const isExcludeDir = dir => excludeDirFilters.some(v => v(dir));
  const isExcludeFile = dir => excludeFilters.some(v => v(dir));
  output.on('close', () => {
    callback(archive.pointer());
  });
  output.on('end', function () {
    logger.info('[info]', 'Data has been drained');
  });
  archive.on('warning', function (err) {
    if (err.code === 'ENOENT') {
      // log warning
      logger.info(err);
    } else {
      // throw error
      throw err;
    }
  });
  archive.on('error', function (err) {
    throw err;
  });
  // @ts-ignore
  archive.pipe(output);
  fileList.forEach(i => {
    const p = _path().default.resolve(basePath, i);
    if ((0, _fs().statSync)(p).isDirectory()) {
      if (isExcludeDir(p)) {
        logger.info('[info]', '跳过目录:', i);
        return;
      }
      archive.directory(p, i, e => {
        const fullPath = _path().default.resolve(p, i);
        if (isExcludeFile(fullPath)) {
          logger.info('[info]', '跳过文件:', fullPath);
          return false;
        }
        return e;
      });
      logger.info('[info]', '添加目录:', i);
    } else {
      const fullPath = _path().default.resolve(p, i);
      if (isExcludeFile(fullPath)) {
        logger.info('[info]', '跳过文件:', fullPath);
        return;
      }
      archive.file(p, {
        name: i
      });
    }
  });
  return archive.finalize();
}
const compileExp = (str, dataSet) => str.replace(/\{\{(\w+)}}/g, (_, k) => {
  return String(dataSet[k] || '');
});
exports.compileExp = compileExp;
function getCwd() {
  return process.cwd();
}
const getPkgInfo = () => {
  const pkgPath = _path().default.join(getCwd(), 'package.json');
  return JSON.parse(_fs().default.readFileSync(pkgPath, 'utf-8'));
};
function pack(packOptions) {
  const pkg = getPkgInfo();
  const file = packOptions.file,
    outDir = packOptions.outDir,
    restOptions = _objectWithoutProperties(packOptions, _excluded);
  const cwd = getCwd();
  const exportFileStr = _path().default.resolve(cwd, outDir || cwd, file || `dist@{{version}}`);
  const exportFile = compileExp(`${exportFileStr}.zip`, _objectSpread({}, pkg));
  const basePath = _path().default.resolve(cwd, 'docker');
  const fileList = (0, _fs().readdirSync)(basePath);
  const options = _objectSpread(_objectSpread({}, restOptions), {}, {
    exportFile,
    basePath,
    fileList
  });
  const start = Date.now();
  const outputDir = _path().default.dirname(exportFile);
  if (!_fs().default.existsSync(outputDir)) {
    _fs().default.mkdirSync(outputDir, {
      recursive: true
    });
  }
  createZip(options, size => {
    const end = Date.now();
    logger.log('[info]', _chalk().default.cyan('============================='));
    logger.log('[info]', _chalk().default.cyan('耗时：' + (end - start) / 1000 + 's'));
    logger.log('[info]', _chalk().default.cyan('大小：' + (0, _filesize().filesize)(size)));
    logger.log('[info]', _chalk().default.cyan('============================='));
    logger.log('[info]', _chalk().default.bgGreen(_chalk().default.black(' DONE ')) + ' ' + _chalk().default.green('pack successfully !'));
  }).then();
}
var _default = () => {
  var _userConfig$pack;
  const userConfig = (0, _getUserConfig.default)({
    cwd: getCwd(),
    env: 'production'
  });
  if (!((_userConfig$pack = userConfig.pack) === null || _userConfig$pack === void 0 ? void 0 : _userConfig$pack.verbose)) {
    logger.info = () => {};
  }
  return pack(_objectSpread({}, userConfig.pack));
};
exports.default = _default;