"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.unwatch = unwatch;
exports.watch = watch;
function _chokidar() {
  const data = _interopRequireDefault(require("chokidar"));
  _chokidar = function _chokidar() {
    return data;
  };
  return data;
}
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
// 按 key 存，值为数组
const watchers = new Map();
function watch(key, files) {
  if (!watchers.has(key)) {
    watchers.set(key, []);
  }
  const watcher = _chokidar().default.watch(files, {
    // ignored: (path: string) => {
    //   return path.indexOf('.ppt') !== -1;
    // },
    // ignore .dotfiles and _mock.js
    ignored: /(^|[\/\\])(_mock.js$|\..)/,
    ignoreInitial: true
  });
  watchers.get(key).push(watcher);
  return watcher;
}
function unwatch(key) {
  if (!key) {
    return Object.keys(watchers).forEach(unwatch);
  }
  if (watchers.has(key)) {
    watchers.get(key).forEach(watcher => {
      watcher.close();
    });
    watchers.delete(key);
  }
}